#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2700five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 2700"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five27004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five27004xi = {
                1: '-1026x671y2405z',
                2: '-1035x1551y1952z',
                3: '-1074x2327y847z',
                4: '-1080x628y2393z',
                5: '-1088x1676y1814z',
                6: '-1126x1510y1933z',
                7: '-1133x582y2380z',
                8: '-113x18y2697z',
                9: '-1184x531y2367z',
                10: '-1185x1631y1794z',
                11: '-1198x2275y821z',
                12: '-1216x1464y1914z',
                13: '-1232x477y2354z',
                14: '-126x817y2570z',
                15: '-1277x419y2341z',
                16: '-1280x1581y1774z',
                17: '-1304x1412y1895z',
                18: '-1320x2216y796z',
                19: '-1320x358y2327z',
                20: '-1360x293y2313z',
                21: '-1373x1525y1754z',
                22: '-1389x1355y1876z',
                23: '-1396x225y2299z',
                24: '-140x15y2696z',
                25: '-1429x154y2285z',
                26: '-1438x2151y770z',
                27: '-1458x81y2270z',
                28: '-1463x1463y1733z',
                29: '-1472x1293y1856z',
                30: '-1483x4y2256z',
                31: '-1551x1396y1712z',
                32: '-1553x1226y1836z',
                33: '-1553x2078y744z',
                34: '-1630x1153y1817z',
                35: '-1635x1324y1691z',
                36: '-1665x2000y718z',
                37: '-168x9y2694z',
                38: '-1703x1076y1797z',
                39: '-1715x1246y1670z',
                40: '-174x835y2561z',
                41: '-1772x1915y692z',
                42: '-1773x994y1776z',
                43: '-1792x1164y1649z',
                44: '-1838x908y1756z',
                45: '-1865x1076y1627z',
                46: '-1875x1824y666z',
                47: '-1899x817y1735z',
                48: '-191x1817y1987z',
                49: '-1933x985y1606z',
                50: '-1955x723y1715z',
                51: '-195x0y2692z',
                52: '-1972x1728y639z',
                53: '-1997x889y1584z',
                54: '-2007x624y1694z',
                55: '-2053x523y1672z',
                56: '-2055x789y1562z',
                57: '-2065x1626y613z',
                58: '-2094x418y1651z',
                59: '-2108x685y1540z',
                60: '-2129x310y1630z',
                61: '-2152x1519y587z',
                62: '-2156x577y1518z',
                63: '-2159x199y1608z',
                64: '-2198x467y1495z',
                65: '-2234x1408y561z',
                66: '-2234x353y1473z',
                67: '-224x849y2553z',
                68: '-2263x90y1645z',
                69: '-2264x238y1450z',
                70: '-2288x119y1427z',
                71: '-2305x0y1404z',
                72: '-2309x1292y534z',
                73: '-2378x1171y508z',
                74: '-2441x1047y481z',
                75: '-2497x920y454z',
                76: '-2546x789y428z',
                77: '-2588x656y401z',
                78: '-2622x520y374z',
                79: '-2649x382y348z',
                80: '-2669x244y321z',
                81: '-2681x104y294z',
                82: '-276x860y2544z',
                83: '-287x1678y2095z',
                84: '-289x1824y1968z',
                85: '-295x2490y999z',
                86: '-32x10y2699z',
                87: '-330x868y2534z',
                88: '-379x1681y2078z',
                89: '-385x873y2525z',
                90: '-388x1826y1950z',
                91: '-427x2481y974z',
                92: '-442x874y2515z',
                93: '-472x1679y2060z',
                94: '-488x1822y1931z',
                95: '-499x872y2505z',
                96: '-558x2464y949z',
                97: '-558x865y2495z',
                98: '-566x1671y2043z',
                99: '-588x1812y1912z',
                100: '-58x16y2699z',
                101: '-617x855y2485z',
                102: '-660x1658y2025z',
                103: '-676x841y2474z',
                104: '-689x1796y1893z',
                105: '-689x2441y924z',
                106: '-6x2y2699z',
                107: '-736x823y2463z',
                108: '-754x1640y2007z',
                109: '-790x1775y1874z',
                110: '-795x800y2452z',
                111: '-819x2410y898z',
                112: '-81x797y2578z',
                113: '-848x1616y1989z',
                114: '-854x774y2441z',
                115: '-85x18y2698z',
                116: '-890x1748y1854z',
                117: '-913x744y2429z',
                118: '-942x1586y1970z',
                119: '-947x2372y873z',
                120: '-970x709y2417z',
                121: '-990x1715y1834z'}
#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2700five4xi" usage = "target function for charge27004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire2700five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2700FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2700FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2700FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2700FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2700FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five27004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2700FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2700FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2700FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five27004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five27004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2700FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2700FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2700FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2700five4xi.py                             
# -------------------------------------------------------------------------------------------------                